Summary:       Utility to administer the Linux Virtual Server
Name:          ipvsadm
Version:       1.31
Release:       4%{?dist}
License:       GPLv2+
URL:           https://kernel.org/pub/linux/utils/kernel/ipvsadm
Source0:       %{url}/%{name}-%{version}.tar.gz
Source1:       ipvsadm.service
Source2:       ipvsadm-config

Patch3000:     0003-ipvsadm-use-CFLAGS-and-LDFLAGS-environment-variables.patch

BuildRequires: gcc libnl3-devel popt-devel systemd make

%{?systemd_requires}

%description
ipvsadm is used to setup, maintain, and inspect the virtual server table in the
Linux kernel. The Linux Virtual Server can be used to build scalable network services
based on a cluster of two or more nodes. The active node of the cluster redirects service
requests to a collection of server hosts that will actually perform the services.
Supported Features include:
  - two transport layer (layer-4) protocols (TCP and UDP)
  - three packet-forwarding methods (NAT, tunneling, and direct routing)
  - eight load balancing algorithms (round robin, weighted round robin, least-connection,
    weighted least-connection, locality-based least-connection, locality-based
    least-connection with replication, destination-hashing, and source-hashing)

%prep
%autosetup -n %{name}-%{version} -p1

%build
# do not make -j for warning to error
make

%install
make install \
    BUILD_ROOT=%{buildroot}%{_prefix} \
    SBIN=%{buildroot}%{_sbindir} \
    MANDIR=%{buildroot}%{_mandir} \
    MAN=%{buildroot}%{_mandir}/man8 \
    INIT=%{buildroot}%{_sysconfdir}/rc.d/init.d \
    %{nil}

rm -f %{buildroot}%{_sysconfdir}/rc.d/init.d/%{name}
install -p -D -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}.service
install -p -D -m 0600 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/%{name}-config

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%files
%doc MAINTAINERS README
%{_unitdir}/%{name}.service
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}-config
%{_sbindir}/%{name}
%{_sbindir}/%{name}-restore
%{_sbindir}/%{name}-save
%{_mandir}/man8/%{name}.8*
%{_mandir}/man8/%{name}-restore.8*
%{_mandir}/man8/%{name}-save.8*

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.31-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.31-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.31-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Dec 23 2022 Shuo Wang <abushwang@tencent.com> - 1.31-1
- initial build
